SystemOrganization addCategory: #'GMF-Window'!

Object subclass: #CreateElementWindow
	instanceVariableNames: 'name type metaModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!CreateElementWindow methodsFor: 'ok actions' stamp: 'volosmat 11/7/2013 22:00'!
doOnOK
	
	! !

!CreateElementWindow methodsFor: 'accesing' stamp: 'volosmat 11/7/2013 19:55'!
metaModel: xModel
	metaModel := xModel! !

!CreateElementWindow methodsFor: 'accesing' stamp: 'volosmat 11/7/2013 20:27'!
name
	^name! !

!CreateElementWindow methodsFor: 'accesing' stamp: 'volosmat 11/7/2013 20:29'!
name: xName
	name := xName! !

!CreateElementWindow methodsFor: 'open' stamp: 'volosmat 11/7/2013 20:31'!
openModal
	|builder dialog content listModel|
 
	builder := UITheme builder.
	listModel := ListModel new list: #('Kind' 'SubKind' 'Phase' 'Role' 'Mode' 'Role' 'Relator' 'RoleMixin' 'Mixin' 'Category' 'Collective' 'Quantity' ).
 	content := (builder newLabelGroup: {
			'Type:'->(  builder 
						newDropListFor: listModel
						list: #list 
						getSelected: #selectionIndex 
						setSelected: #selectionIndex: 
						help: 'Element type').
  			
  			'Name' ->(( builder
   						newTextEntryFor: self
						getText: #name 
						setText: #name: 
						help: 'Enter element name')
   					acceptOnCR: false;
   					minWidth: 200 ).
	}).
	dialog := builder newPluggableDialogWindow:'Create element' for: content.
	builder openModal: dialog.
	
 	type := listModel selectedItem.
	dialog cancelled ifFalse: [self doOnOK ].! !

!CreateElementWindow methodsFor: 'accesing' stamp: 'volosmat 11/7/2013 20:27'!
type
	^type! !

Morph subclass: #GMFViewMorph
	instanceVariableNames: 'surface session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMFViewMorph methodsFor: 'session' stamp: 'volosmat 11/7/2013 22:41'!
checkSession
	session == Smalltalk session ifFalse: [ 
		"just reset the surface"
		surface := nil.
		session := Smalltalk session.
	]! !

!GMFViewMorph methodsFor: 'drawing' stamp: 'volosmat 11/7/2013 22:42'!
drawOn: aCanvas
	self checkSession.
	
	surface ifNil: [  surface := AthensCairoSurface extent: self extent asIntegerPoint.
				     surface drawDuring: [ :canvas | surface clear: Color white ].
				"test draw remove in next release"
				surface drawDuring: [:canvas | 
				canvas setPaint: Color darkGray.
				canvas setShape: (70@90 corner: 200@200).
				canvas draw]
				].

	aCanvas drawImage: surface asForm at: bounds origin.! !

!GMFViewMorph methodsFor: 'initialize-release' stamp: 'volosmat 11/7/2013 22:41'!
initialize
	super initialize.
	session := Smalltalk session.
	
	self hResizing: #spaceFill;
		 vResizing: #spaceFill! !

ComposableModel subclass: #GMF
	instanceVariableNames: 'viewport surface textpane openFile saveFile createElement generateCode createAttribut createMethod createAssociation metaModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-Window'!

!GMF class methodsFor: 'specs' stamp: 'volosmat 11/7/2013 18:30'!
defaultSpec
	<spec: #default>
	^ SpecLayout composed
		newColumn: [:r | 
			r newRow: [ :col | 
				col add: #saveFileButton; 
				add: #openFileButton;
				add: #generateCodeButton;
				add: #createElementButton;
				add: #createAttributButton;
				add: #createMethodButton;
				add: #createAssociationButton.
				] height: 30;
			  newRow: [ :col1 | 
			  	col1 newColumn: [:col | col add: #viewMorph];
			  		 newColumn: [:col | col add: #textPane ] width: 150 ] ] ! !

!GMF class methodsFor: 'open' stamp: 'volosmat 11/7/2013 12:30'!
open
	^ self new openWithSpec extent: 900@600! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
createAssociation
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
createAssociationButton
	^createAssociation! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
createAttribut
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
createAttributButton
	^createAttribut! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 22:00'!
createElement
	CreateElementWindow new 
		metaModel: metaModel;
		openModal.
! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
createElementButton
	^ createElement! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
createMethod
! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
createMethodButton
	^createMethod! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
generateCode
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
generateCodeButton
	^ generateCode! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 11/7/2013 14:37'!
initializePresenter

	openFile whenActionPerformedDo: [  self openFile ].
	createElement whenActionPerformedDo: [ self createElement ].! !

!GMF methodsFor: 'initialization' stamp: 'volosmat 11/7/2013 20:39'!
initializeWidgets 
		self instantiateModels: #(
		textpane	 	 	TextModel
		openFile		 	ButtonModel
		saveFile		 	ButtonModel
		createElement   	ButtonModel
		createAttribut   	ButtonModel
		createMethod   	ButtonModel
		createAssociation  	ButtonModel
		generateCode   	ButtonModel
	).
		saveFile
			label: 'Save'; 
			state: false.
		openFile 
			label: 'Open'; 
			state: false.
		generateCode 
			label: 'Generate'; 
			state: false.
		createElement 
			label: 'Create element'; 
			state: false.
		createAttribut 
			label: 'Create attribut'; 
			state: false.
		createMethod
			label: 'Create method'; 
			state: false.
		createAssociation
			label: 'Create association'; 
			state: false.
		
	textpane doItReceiver: self viewMorph.
	textpane text: 'Simple text class
--------------------------------
testAttr1: String[1]
testAttr2: Integer[1]
--------------------------------
testMethod(): bool'.

	metaModel := MetaModel new.! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:59'!
openFile
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
openFileButton
	^openFile! !

!GMF methodsFor: 'button actions' stamp: 'volosmat 11/7/2013 12:53'!
saveFile
	! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/7/2013 12:52'!
saveFileButton
	^ saveFile! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/6/2013 23:19'!
textPane
	^textpane! !

!GMF methodsFor: 'text' stamp: 'volosmat 11/6/2013 22:46'!
title
	^ 'GMF in Pharo'! !

!GMF methodsFor: 'widgets' stamp: 'volosmat 11/6/2013 22:58'!
viewMorph
	 ^ viewport ifNil: [  viewport := GMFViewMorph new  ]! !
